package cmd

// CryptApiResponse hold a response for currency conversions, used in !convert
type CryptApiResponse struct {
	Ticker    CryptonatorRate `json:"ticker"`
	Timestamp int             `json:"timestamp"`
	Success   bool            `json:"success"`
	Error     string          `json:"error"`
}

type CryptonatorRate struct {
	Base    string              `json:"base"`
	Target  string              `json:"target"`
	Price   string              `json:"price"`
	Volume  string              `json:"volume"`
	Change  string              `json:"change"`
	Markets []CryptonatorMarket `json:"markets,omitempty"`
}

type CryptonatorMarket struct {
	Market string  `json:"market"`
	Price  string  `json:"price"`
	Volume float64 `json:"volume"`
}
